//	TorusGames-2D.vs
//
//	© 2014 by Jeff Weeks
//	See TermsOfUse.txt

uniform vec4	uniTransformationX,	//	the "model transformation"
				uniTransformationY,
				uniViewTransformation;	//	(sx, sy, ∆x, ∆y) defines view transformation
										//	
										//		         ( sx   0   0 )
										//		(x, y, 1)(  0  sy   0 )
										//		         ( ∆x  ∆y   1 )

in vec3			atrPosition;	//	(x, y, c) where c is the "endcap coordinate" described
								//		at the top of TorusGamesRectangleWithEndcaps.c

#ifdef USE_TEXTURE
uniform vec4	uniTextureCoordTransform;
in vec2			atrTextureCoordinates;
out vec2		varTextureCoordinates;
#endif


void main()
{
	float	tmpX,
			tmpY;
	
	tmpX = dot(uniTransformationX, vec4(atrPosition, 1.0));
	tmpY = dot(uniTransformationY, vec4(atrPosition, 1.0));

	gl_Position = vec4(	uniViewTransformation[0]*tmpX + uniViewTransformation[2],
						uniViewTransformation[1]*tmpY + uniViewTransformation[3],
						0.0,
						1.0);

#ifdef USE_TEXTURE
	varTextureCoordinates = uniTextureCoordTransform.xy * atrTextureCoordinates
						  + uniTextureCoordTransform.zw;
#endif
}
