//	TorusGames-3D-GameContents.fs
//
//	© 2014 by Jeff Weeks
//	See TermsOfUse.txt

in vec4	varDiffuseColor;	//	premultiplied alpha

#ifdef CLIP_TO_FRAME_CELL
#ifdef GL_ES
in vec4	varClipDistancesA,	//	eight client clip distances,
		varClipDistancesB;	//		packaged as two vec4's.
#endif
#endif

void main()
{
#ifdef CLIP_TO_FRAME_CELL
#ifdef GL_ES
	//	Use the "discard" keyword to simulate client clip planes.
	//
	//	Technical Note:  When multisampling is enabled (as it
	//	always is in 3D Torus Games), this simulated clipping
	//	is good but not perfect.  The flaw is that unlike real clipping,
	//	which may accept some sample points while rejecting
	//	others within the same pixel, the "discard" keyword
	//	accepts or rejects the pixel as a whole.  Say for example
	//	we're clipping to x == 0.5, and a pixel's sample points
	//	sit at x = 0.46, 0.48, 0.50 and 0.52.  If the pixel's center
	//	sits at, say, x = 0.49, then the whole pixel will be accepted,
	//	including the sample points at x = 0.50 and 0.52.
	//	This may create an artifact in which, for example,
	//	a sample point at x = 0.52 from a white tube gets drawn
	//	in front of a sample at x = 0.51 from a grey slice-disk,
	//	even though we had intended to clip the tube at x == 0.5.
	//	
	if (varClipDistancesA.x < 0.0
	 || varClipDistancesA.y < 0.0
	 || varClipDistancesA.z < 0.0
	 || varClipDistancesA.w < 0.0
	 || varClipDistancesB.x < 0.0
	 || varClipDistancesB.y < 0.0
	 || varClipDistancesB.z < 0.0
	 || varClipDistancesB.w < 0.0)
	{
		discard;
	}
#endif
#endif

	gl_FragColor = varDiffuseColor;
}
