//	TorusGames-3D-WallHalfTurn.fs
//
//	© 2014 by Jeff Weeks
//	See TermsOfUse.txt

in vec2	varTextureCoordinates;
in vec4	varDiffuseColor;	//	premultiplied alpha

void main()
{
	vec2	tmpWrappedTexCoords,
			tmpShiftedTexCoords;
	bool	tmpParity;
	
	//	Wrap coordinates to [0,1).
	tmpWrappedTexCoords = fract(varTextureCoordinates);
	
	//	Shift coordinates from [0,1) to [-1/2, 1/2).
	tmpShiftedTexCoords = tmpWrappedTexCoords - 0.5;
	
	//	The color should flip at the s and t axes.
	tmpParity =
	(
		(tmpShiftedTexCoords[0] >= 0.0)
	 ==
		(tmpShiftedTexCoords[1] >= 0.0)
	);

	gl_FragColor = (tmpParity ?
		varDiffuseColor * vec4(0.875, 0.875, 0.875, 1.000) :
		varDiffuseColor);
}
