//	TorusGames-3D-WallReflection.fs
//
//	© 2014 by Jeff Weeks
//	See TermsOfUse.txt

in vec2	varTextureCoordinates;
in vec4	varDiffuseColor;	//	premultiplied alpha

void main()
{
	vec2	tmpWrappedTexCoords,
			tmpShiftedTexCoords;
	bool	tmpParity;
	
	//	Wrap coordinates to [0,1).
	tmpWrappedTexCoords = fract(varTextureCoordinates);
	
	//	Shift coordinates from [0,1) to [-1/2, 1/2).
	tmpShiftedTexCoords = tmpWrappedTexCoords - 0.5;
		
	//	The color should flip at the t axis.
	tmpParity = (tmpShiftedTexCoords[0] >= 0.0);

	gl_FragColor = (tmpParity ?
		varDiffuseColor * vec4(1.000, 0.750, 0.750, 1.000) :
		varDiffuseColor);
}
